Index: /pjproject/trunk/build.symbian/pjsipU.def
===================================================================
--- /pjproject/trunk/build.symbian/pjsipU.def	(revision 1493)
+++ /pjproject/trunk/build.symbian/pjsipU.def	(revision 1494)
@@ -10,261 +10,263 @@
 	pjsip_auth_clt_reinit_req                @ 9 NONAME
 	pjsip_auth_clt_set_credentials           @ 10 NONAME
-	pjsip_auth_deinit_parser                 @ 11 NONAME
-	pjsip_auth_init_parser                   @ 12 NONAME
-	pjsip_auth_srv_challenge                 @ 13 NONAME
-	pjsip_auth_srv_init                      @ 14 NONAME
-	pjsip_auth_srv_verify                    @ 15 NONAME
-	pjsip_authorization_hdr_create           @ 16 NONAME
-	pjsip_bye_method                         @ 17 NONAME
-	pjsip_calculate_branch_id                @ 18 NONAME
-	pjsip_cancel_method                      @ 19 NONAME
-	pjsip_cid_hdr_create                     @ 20 NONAME
-	pjsip_cid_hdr_init                       @ 21 NONAME
-	pjsip_clen_hdr_create                    @ 22 NONAME
-	pjsip_clen_hdr_init                      @ 23 NONAME
-	pjsip_clone_text_data                    @ 24 NONAME
-	pjsip_concat_param_imp                   @ 25 NONAME
-	pjsip_contact_hdr_create                 @ 26 NONAME
-	pjsip_contact_hdr_init                   @ 27 NONAME
-	pjsip_cseq_hdr_create                    @ 28 NONAME
-	pjsip_cseq_hdr_init                      @ 29 NONAME
-	pjsip_ctype_hdr_create                   @ 30 NONAME
-	pjsip_ctype_hdr_init                     @ 31 NONAME
-	pjsip_dlg_add_usage                      @ 32 NONAME
-	pjsip_dlg_create_request                 @ 33 NONAME
-	pjsip_dlg_create_response                @ 34 NONAME
-	pjsip_dlg_create_uac                     @ 35 NONAME
-	pjsip_dlg_create_uas                     @ 36 NONAME
-	pjsip_dlg_dec_lock                       @ 37 NONAME
-	pjsip_dlg_dec_session                    @ 38 NONAME
-	pjsip_dlg_fork                           @ 39 NONAME
-	pjsip_dlg_get_mod_data                   @ 40 NONAME
-	pjsip_dlg_inc_lock                       @ 41 NONAME
-	pjsip_dlg_inc_session                    @ 42 NONAME
-	pjsip_dlg_modify_response                @ 43 NONAME
-	pjsip_dlg_respond                        @ 44 NONAME
-	pjsip_dlg_send_request                   @ 45 NONAME
-	pjsip_dlg_send_response                  @ 46 NONAME
-	pjsip_dlg_set_mod_data                   @ 47 NONAME
-	pjsip_dlg_set_route_set                  @ 48 NONAME
-	pjsip_dlg_set_transport                  @ 49 NONAME
-	pjsip_dlg_terminate                      @ 50 NONAME
-	pjsip_dlg_try_inc_lock                   @ 51 NONAME
-	pjsip_endpt_acquire_transport            @ 52 NONAME
-	pjsip_endpt_add_capability               @ 53 NONAME
-	pjsip_endpt_cancel_timer                 @ 54 NONAME
-	pjsip_endpt_create                       @ 55 NONAME
-	pjsip_endpt_create_ack                   @ 56 NONAME
-	pjsip_endpt_create_cancel                @ 57 NONAME
-	pjsip_endpt_create_pool                  @ 58 NONAME
-	pjsip_endpt_create_request               @ 59 NONAME
-	pjsip_endpt_create_request_from_hdr      @ 60 NONAME
-	pjsip_endpt_create_request_fwd           @ 61 NONAME
-	pjsip_endpt_create_resolver              @ 62 NONAME
-	pjsip_endpt_create_response              @ 63 NONAME
-	pjsip_endpt_create_response_fwd          @ 64 NONAME
-	pjsip_endpt_create_tdata                 @ 65 NONAME
-	pjsip_endpt_destroy                      @ 66 NONAME
-	pjsip_endpt_dump                         @ 67 NONAME
-	pjsip_endpt_get_capability               @ 68 NONAME
-	pjsip_endpt_get_ioqueue                  @ 69 NONAME
-	pjsip_endpt_get_request_headers          @ 70 NONAME
-	pjsip_endpt_get_resolver                 @ 71 NONAME
-	pjsip_endpt_get_timer_heap               @ 72 NONAME
-	pjsip_endpt_get_tpmgr                    @ 73 NONAME
-	pjsip_endpt_handle_events                @ 74 NONAME
-	pjsip_endpt_handle_events2               @ 75 NONAME
-	pjsip_endpt_has_capability               @ 76 NONAME
-	pjsip_endpt_log_error                    @ 77 NONAME
-	pjsip_endpt_name                         @ 78 NONAME
-	pjsip_endpt_register_module              @ 79 NONAME
-	pjsip_endpt_release_pool                 @ 80 NONAME
-	pjsip_endpt_resolve                      @ 81 NONAME
-	pjsip_endpt_respond                      @ 82 NONAME
-	pjsip_endpt_respond_stateless            @ 83 NONAME
-	pjsip_endpt_schedule_timer               @ 84 NONAME
-	pjsip_endpt_send_raw                     @ 85 NONAME
-	pjsip_endpt_send_raw_to_uri              @ 86 NONAME
-	pjsip_endpt_send_request                 @ 87 NONAME
-	pjsip_endpt_send_request_stateless       @ 88 NONAME
-	pjsip_endpt_send_response                @ 89 NONAME
-	pjsip_endpt_send_response2               @ 90 NONAME
-	pjsip_endpt_set_resolver                 @ 91 NONAME
-	pjsip_endpt_unregister_module            @ 92 NONAME
-	pjsip_event_str                          @ 93 NONAME
-	pjsip_expires_hdr_create                 @ 94 NONAME
-	pjsip_expires_hdr_init                   @ 95 NONAME
-	pjsip_find_msg                           @ 96 NONAME
-	pjsip_from_hdr_create                    @ 97 NONAME
-	pjsip_from_hdr_init                      @ 98 NONAME
-	pjsip_fromto_hdr_set_from                @ 99 NONAME
-	pjsip_fromto_hdr_set_to                  @ 100 NONAME
-	pjsip_generic_array_hdr_create           @ 101 NONAME
-	pjsip_generic_array_hdr_init             @ 102 NONAME
-	pjsip_generic_int_hdr_create             @ 103 NONAME
-	pjsip_generic_int_hdr_init               @ 104 NONAME
-	pjsip_generic_string_hdr_create          @ 105 NONAME
-	pjsip_generic_string_hdr_init            @ 106 NONAME
-	pjsip_generic_string_hdr_init2           @ 107 NONAME
-	pjsip_get_ack_method                     @ 108 NONAME
-	pjsip_get_bye_method                     @ 109 NONAME
-	pjsip_get_cancel_method                  @ 110 NONAME
-	pjsip_get_invite_method                  @ 111 NONAME
-	pjsip_get_options_method                 @ 112 NONAME
-	pjsip_get_register_method                @ 113 NONAME
-	pjsip_get_request_dest                   @ 114 NONAME
-	pjsip_get_response_addr                  @ 115 NONAME
-	pjsip_get_status_text                    @ 116 NONAME
-	pjsip_hdr_clone                          @ 117 NONAME
-	pjsip_hdr_print_on                       @ 118 NONAME
-	pjsip_hdr_shallow_clone                  @ 119 NONAME
-	pjsip_invite_method                      @ 120 NONAME
-	pjsip_loop_set_delay                     @ 121 NONAME
-	pjsip_loop_set_discard                   @ 122 NONAME
-	pjsip_loop_set_failure                   @ 123 NONAME
-	pjsip_loop_set_recv_delay                @ 124 NONAME
-	pjsip_loop_set_send_callback_delay       @ 125 NONAME
-	pjsip_loop_start                         @ 126 NONAME
-	pjsip_max_fwd_hdr_create                 @ 127 NONAME
-	pjsip_max_fwd_hdr_init                   @ 128 NONAME
-	pjsip_method_cmp                         @ 129 NONAME
-	pjsip_method_copy                        @ 130 NONAME
-	pjsip_method_creates_dialog              @ 131 NONAME
-	pjsip_method_init                        @ 132 NONAME
-	pjsip_method_init_np                     @ 133 NONAME
-	pjsip_method_set                         @ 134 NONAME
-	pjsip_min_expires_hdr_create             @ 135 NONAME
-	pjsip_min_expires_hdr_init               @ 136 NONAME
-	pjsip_msg_body_clone                     @ 137 NONAME
-	pjsip_msg_body_copy                      @ 138 NONAME
-	pjsip_msg_body_create                    @ 139 NONAME
-	pjsip_msg_clone                          @ 140 NONAME
-	pjsip_msg_create                         @ 141 NONAME
-	pjsip_msg_find_hdr                       @ 142 NONAME
-	pjsip_msg_find_hdr_by_name               @ 143 NONAME
-	pjsip_msg_find_remove_hdr                @ 144 NONAME
-	pjsip_msg_print                          @ 145 NONAME
-	pjsip_name_addr_assign                   @ 146 NONAME
-	pjsip_name_addr_create                   @ 147 NONAME
-	pjsip_name_addr_init                     @ 148 NONAME
-	pjsip_options_method                     @ 149 NONAME
-	pjsip_param_cfind                        @ 150 NONAME
-	pjsip_param_clone                        @ 151 NONAME
-	pjsip_param_find                         @ 152 NONAME
-	pjsip_param_print_on                     @ 153 NONAME
-	pjsip_param_shallow_clone                @ 154 NONAME
-	pjsip_parse_end_hdr_imp                  @ 155 NONAME
-	pjsip_parse_hdr                          @ 156 NONAME
-	pjsip_parse_msg                          @ 157 NONAME
-	pjsip_parse_param_imp                    @ 158 NONAME
-	pjsip_parse_rdata                        @ 159 NONAME
-	pjsip_parse_status_line                  @ 160 NONAME
-	pjsip_parse_uri                          @ 161 NONAME
-	pjsip_parse_uri_param_imp                @ 162 NONAME
-	pjsip_parser_const                       @ 163 NONAME
-	pjsip_print_text_body                    @ 164 NONAME
-	pjsip_process_route_set                  @ 165 NONAME
-	pjsip_proxy_authenticate_hdr_create      @ 166 NONAME
-	pjsip_proxy_authorization_hdr_create     @ 167 NONAME
-	pjsip_rdata_get_dlg                      @ 168 NONAME
-	pjsip_rdata_get_tsx                      @ 169 NONAME
-	pjsip_register_hdr_parser                @ 170 NONAME
-	pjsip_register_method                    @ 171 NONAME
-	pjsip_register_uri_parser                @ 172 NONAME
-	pjsip_require_hdr_create                 @ 173 NONAME
-	pjsip_require_hdr_init                   @ 174 NONAME
-	pjsip_resolve                            @ 175 NONAME
-	pjsip_resolver_create                    @ 176 NONAME
-	pjsip_resolver_destroy                   @ 177 NONAME
-	pjsip_resolver_get_resolver              @ 178 NONAME
-	pjsip_resolver_set_resolver              @ 179 NONAME
-	pjsip_retry_after_hdr_create             @ 180 NONAME
-	pjsip_retry_after_hdr_init               @ 181 NONAME
-	pjsip_role_name                          @ 182 NONAME
-	pjsip_route_hdr_create                   @ 183 NONAME
-	pjsip_route_hdr_init                     @ 184 NONAME
-	pjsip_routing_hdr_set_route              @ 185 NONAME
-	pjsip_routing_hdr_set_rr                 @ 186 NONAME
-	pjsip_rr_hdr_create                      @ 187 NONAME
-	pjsip_rr_hdr_init                        @ 188 NONAME
-	pjsip_rx_data_get_info                   @ 189 NONAME
-	pjsip_sip_uri_assign                     @ 190 NONAME
-	pjsip_sip_uri_create                     @ 191 NONAME
-	pjsip_sip_uri_init                       @ 192 NONAME
-	pjsip_sip_uri_set_secure                 @ 193 NONAME
-	pjsip_strerror                           @ 194 NONAME
-	pjsip_supported_hdr_create               @ 195 NONAME
-	pjsip_supported_hdr_init                 @ 196 NONAME
-	pjsip_tcp_transport_start                @ 197 NONAME
-	pjsip_tcp_transport_start2               @ 198 NONAME
-	pjsip_tel_nb_cmp                         @ 199 NONAME
-	pjsip_tel_uri_create                     @ 200 NONAME
-	pjsip_to_hdr_create                      @ 201 NONAME
-	pjsip_to_hdr_init                        @ 202 NONAME
-	pjsip_tpmgr_acquire_transport            @ 203 NONAME
-	pjsip_tpmgr_create                       @ 204 NONAME
-	pjsip_tpmgr_destroy                      @ 205 NONAME
-	pjsip_tpmgr_dump_transports              @ 206 NONAME
-	pjsip_tpmgr_find_local_addr              @ 207 NONAME
-	pjsip_tpmgr_get_transport_count          @ 208 NONAME
-	pjsip_tpmgr_receive_packet               @ 209 NONAME
-	pjsip_tpmgr_register_tpfactory           @ 210 NONAME
-	pjsip_tpmgr_send_raw                     @ 211 NONAME
-	pjsip_tpmgr_unregister_tpfactory         @ 212 NONAME
-	pjsip_tpselector_add_ref                 @ 213 NONAME
-	pjsip_tpselector_dec_ref                 @ 214 NONAME
-	pjsip_transport_add_ref                  @ 215 NONAME
-	pjsip_transport_dec_ref                  @ 216 NONAME
-	pjsip_transport_destroy                  @ 217 NONAME
-	pjsip_transport_get_default_port_for_type @ 218 NONAME
-	pjsip_transport_get_flag_from_type       @ 219 NONAME
-	pjsip_transport_get_type_from_flag       @ 220 NONAME
-	pjsip_transport_get_type_from_name       @ 221 NONAME
-	pjsip_transport_get_type_name            @ 222 NONAME
-	pjsip_transport_register                 @ 223 NONAME
-	pjsip_transport_register_type            @ 224 NONAME
-	pjsip_transport_send                     @ 225 NONAME
-	pjsip_transport_shutdown                 @ 226 NONAME
-	pjsip_tsx_create_key                     @ 227 NONAME
-	pjsip_tsx_create_uac                     @ 228 NONAME
-	pjsip_tsx_create_uas                     @ 229 NONAME
-	pjsip_tsx_get_dlg                        @ 230 NONAME
-	pjsip_tsx_layer_destroy                  @ 231 NONAME
-	pjsip_tsx_layer_dump                     @ 232 NONAME
-	pjsip_tsx_layer_find_tsx                 @ 233 NONAME
-	pjsip_tsx_layer_init_module              @ 234 NONAME
-	pjsip_tsx_layer_instance                 @ 235 NONAME
-	pjsip_tsx_recv_msg                       @ 236 NONAME
-	pjsip_tsx_retransmit_no_state            @ 237 NONAME
-	pjsip_tsx_send_msg                       @ 238 NONAME
-	pjsip_tsx_set_transport                  @ 239 NONAME
-	pjsip_tsx_state_str                      @ 240 NONAME
-	pjsip_tsx_stop_retransmit                @ 241 NONAME
-	pjsip_tsx_terminate                      @ 242 NONAME
-	pjsip_tx_data_add_ref                    @ 243 NONAME
-	pjsip_tx_data_create                     @ 244 NONAME
-	pjsip_tx_data_dec_ref                    @ 245 NONAME
-	pjsip_tx_data_get_info                   @ 246 NONAME
-	pjsip_tx_data_invalidate_msg             @ 247 NONAME
-	pjsip_tx_data_is_valid                   @ 248 NONAME
-	pjsip_tx_data_set_transport              @ 249 NONAME
-	pjsip_ua_destroy                         @ 250 NONAME
-	pjsip_ua_dump                            @ 251 NONAME
-	pjsip_ua_find_dialog                     @ 252 NONAME
-	pjsip_ua_get_endpt                       @ 253 NONAME
-	pjsip_ua_init_module                     @ 254 NONAME
-	pjsip_ua_instance                        @ 255 NONAME
-	pjsip_ua_register_dlg                    @ 256 NONAME
-	pjsip_ua_unregister_dlg                  @ 257 NONAME
-	pjsip_udp_transport_attach               @ 258 NONAME
-	pjsip_udp_transport_get_socket           @ 259 NONAME
-	pjsip_udp_transport_pause                @ 260 NONAME
-	pjsip_udp_transport_restart              @ 261 NONAME
-	pjsip_udp_transport_start                @ 262 NONAME
-	pjsip_unsupported_hdr_create             @ 263 NONAME
-	pjsip_unsupported_hdr_init               @ 264 NONAME
-	pjsip_via_hdr_create                     @ 265 NONAME
-	pjsip_via_hdr_init                       @ 266 NONAME
-	pjsip_warning_hdr_create                 @ 267 NONAME
-	pjsip_warning_hdr_create_from_status     @ 268 NONAME
-	pjsip_www_authenticate_hdr_create        @ 269 NONAME
+	pjsip_auth_create_digest                 @ 11 NONAME
+	pjsip_auth_deinit_parser                 @ 12 NONAME
+	pjsip_auth_init_parser                   @ 13 NONAME
+	pjsip_auth_srv_challenge                 @ 14 NONAME
+	pjsip_auth_srv_init                      @ 15 NONAME
+	pjsip_auth_srv_verify                    @ 16 NONAME
+	pjsip_authorization_hdr_create           @ 17 NONAME
+	pjsip_bye_method                         @ 18 NONAME
+	pjsip_calculate_branch_id                @ 19 NONAME
+	pjsip_cancel_method                      @ 20 NONAME
+	pjsip_cid_hdr_create                     @ 21 NONAME
+	pjsip_cid_hdr_init                       @ 22 NONAME
+	pjsip_clen_hdr_create                    @ 23 NONAME
+	pjsip_clen_hdr_init                      @ 24 NONAME
+	pjsip_clone_text_data                    @ 25 NONAME
+	pjsip_concat_param_imp                   @ 26 NONAME
+	pjsip_contact_hdr_create                 @ 27 NONAME
+	pjsip_contact_hdr_init                   @ 28 NONAME
+	pjsip_cred_info_dup                      @ 29 NONAME
+	pjsip_cseq_hdr_create                    @ 30 NONAME
+	pjsip_cseq_hdr_init                      @ 31 NONAME
+	pjsip_ctype_hdr_create                   @ 32 NONAME
+	pjsip_ctype_hdr_init                     @ 33 NONAME
+	pjsip_dlg_add_usage                      @ 34 NONAME
+	pjsip_dlg_create_request                 @ 35 NONAME
+	pjsip_dlg_create_response                @ 36 NONAME
+	pjsip_dlg_create_uac                     @ 37 NONAME
+	pjsip_dlg_create_uas                     @ 38 NONAME
+	pjsip_dlg_dec_lock                       @ 39 NONAME
+	pjsip_dlg_dec_session                    @ 40 NONAME
+	pjsip_dlg_fork                           @ 41 NONAME
+	pjsip_dlg_get_mod_data                   @ 42 NONAME
+	pjsip_dlg_inc_lock                       @ 43 NONAME
+	pjsip_dlg_inc_session                    @ 44 NONAME
+	pjsip_dlg_modify_response                @ 45 NONAME
+	pjsip_dlg_respond                        @ 46 NONAME
+	pjsip_dlg_send_request                   @ 47 NONAME
+	pjsip_dlg_send_response                  @ 48 NONAME
+	pjsip_dlg_set_mod_data                   @ 49 NONAME
+	pjsip_dlg_set_route_set                  @ 50 NONAME
+	pjsip_dlg_set_transport                  @ 51 NONAME
+	pjsip_dlg_terminate                      @ 52 NONAME
+	pjsip_dlg_try_inc_lock                   @ 53 NONAME
+	pjsip_endpt_acquire_transport            @ 54 NONAME
+	pjsip_endpt_add_capability               @ 55 NONAME
+	pjsip_endpt_cancel_timer                 @ 56 NONAME
+	pjsip_endpt_create                       @ 57 NONAME
+	pjsip_endpt_create_ack                   @ 58 NONAME
+	pjsip_endpt_create_cancel                @ 59 NONAME
+	pjsip_endpt_create_pool                  @ 60 NONAME
+	pjsip_endpt_create_request               @ 61 NONAME
+	pjsip_endpt_create_request_from_hdr      @ 62 NONAME
+	pjsip_endpt_create_request_fwd           @ 63 NONAME
+	pjsip_endpt_create_resolver              @ 64 NONAME
+	pjsip_endpt_create_response              @ 65 NONAME
+	pjsip_endpt_create_response_fwd          @ 66 NONAME
+	pjsip_endpt_create_tdata                 @ 67 NONAME
+	pjsip_endpt_destroy                      @ 68 NONAME
+	pjsip_endpt_dump                         @ 69 NONAME
+	pjsip_endpt_get_capability               @ 70 NONAME
+	pjsip_endpt_get_ioqueue                  @ 71 NONAME
+	pjsip_endpt_get_request_headers          @ 72 NONAME
+	pjsip_endpt_get_resolver                 @ 73 NONAME
+	pjsip_endpt_get_timer_heap               @ 74 NONAME
+	pjsip_endpt_get_tpmgr                    @ 75 NONAME
+	pjsip_endpt_handle_events                @ 76 NONAME
+	pjsip_endpt_handle_events2               @ 77 NONAME
+	pjsip_endpt_has_capability               @ 78 NONAME
+	pjsip_endpt_log_error                    @ 79 NONAME
+	pjsip_endpt_name                         @ 80 NONAME
+	pjsip_endpt_register_module              @ 81 NONAME
+	pjsip_endpt_release_pool                 @ 82 NONAME
+	pjsip_endpt_resolve                      @ 83 NONAME
+	pjsip_endpt_respond                      @ 84 NONAME
+	pjsip_endpt_respond_stateless            @ 85 NONAME
+	pjsip_endpt_schedule_timer               @ 86 NONAME
+	pjsip_endpt_send_raw                     @ 87 NONAME
+	pjsip_endpt_send_raw_to_uri              @ 88 NONAME
+	pjsip_endpt_send_request                 @ 89 NONAME
+	pjsip_endpt_send_request_stateless       @ 90 NONAME
+	pjsip_endpt_send_response                @ 91 NONAME
+	pjsip_endpt_send_response2               @ 92 NONAME
+	pjsip_endpt_set_resolver                 @ 93 NONAME
+	pjsip_endpt_unregister_module            @ 94 NONAME
+	pjsip_event_str                          @ 95 NONAME
+	pjsip_expires_hdr_create                 @ 96 NONAME
+	pjsip_expires_hdr_init                   @ 97 NONAME
+	pjsip_find_msg                           @ 98 NONAME
+	pjsip_from_hdr_create                    @ 99 NONAME
+	pjsip_from_hdr_init                      @ 100 NONAME
+	pjsip_fromto_hdr_set_from                @ 101 NONAME
+	pjsip_fromto_hdr_set_to                  @ 102 NONAME
+	pjsip_generic_array_hdr_create           @ 103 NONAME
+	pjsip_generic_array_hdr_init             @ 104 NONAME
+	pjsip_generic_int_hdr_create             @ 105 NONAME
+	pjsip_generic_int_hdr_init               @ 106 NONAME
+	pjsip_generic_string_hdr_create          @ 107 NONAME
+	pjsip_generic_string_hdr_init            @ 108 NONAME
+	pjsip_generic_string_hdr_init2           @ 109 NONAME
+	pjsip_get_ack_method                     @ 110 NONAME
+	pjsip_get_bye_method                     @ 111 NONAME
+	pjsip_get_cancel_method                  @ 112 NONAME
+	pjsip_get_invite_method                  @ 113 NONAME
+	pjsip_get_options_method                 @ 114 NONAME
+	pjsip_get_register_method                @ 115 NONAME
+	pjsip_get_request_dest                   @ 116 NONAME
+	pjsip_get_response_addr                  @ 117 NONAME
+	pjsip_get_status_text                    @ 118 NONAME
+	pjsip_hdr_clone                          @ 119 NONAME
+	pjsip_hdr_print_on                       @ 120 NONAME
+	pjsip_hdr_shallow_clone                  @ 121 NONAME
+	pjsip_invite_method                      @ 122 NONAME
+	pjsip_loop_set_delay                     @ 123 NONAME
+	pjsip_loop_set_discard                   @ 124 NONAME
+	pjsip_loop_set_failure                   @ 125 NONAME
+	pjsip_loop_set_recv_delay                @ 126 NONAME
+	pjsip_loop_set_send_callback_delay       @ 127 NONAME
+	pjsip_loop_start                         @ 128 NONAME
+	pjsip_max_fwd_hdr_create                 @ 129 NONAME
+	pjsip_max_fwd_hdr_init                   @ 130 NONAME
+	pjsip_method_cmp                         @ 131 NONAME
+	pjsip_method_copy                        @ 132 NONAME
+	pjsip_method_creates_dialog              @ 133 NONAME
+	pjsip_method_init                        @ 134 NONAME
+	pjsip_method_init_np                     @ 135 NONAME
+	pjsip_method_set                         @ 136 NONAME
+	pjsip_min_expires_hdr_create             @ 137 NONAME
+	pjsip_min_expires_hdr_init               @ 138 NONAME
+	pjsip_msg_body_clone                     @ 139 NONAME
+	pjsip_msg_body_copy                      @ 140 NONAME
+	pjsip_msg_body_create                    @ 141 NONAME
+	pjsip_msg_clone                          @ 142 NONAME
+	pjsip_msg_create                         @ 143 NONAME
+	pjsip_msg_find_hdr                       @ 144 NONAME
+	pjsip_msg_find_hdr_by_name               @ 145 NONAME
+	pjsip_msg_find_remove_hdr                @ 146 NONAME
+	pjsip_msg_print                          @ 147 NONAME
+	pjsip_name_addr_assign                   @ 148 NONAME
+	pjsip_name_addr_create                   @ 149 NONAME
+	pjsip_name_addr_init                     @ 150 NONAME
+	pjsip_options_method                     @ 151 NONAME
+	pjsip_param_cfind                        @ 152 NONAME
+	pjsip_param_clone                        @ 153 NONAME
+	pjsip_param_find                         @ 154 NONAME
+	pjsip_param_print_on                     @ 155 NONAME
+	pjsip_param_shallow_clone                @ 156 NONAME
+	pjsip_parse_end_hdr_imp                  @ 157 NONAME
+	pjsip_parse_hdr                          @ 158 NONAME
+	pjsip_parse_msg                          @ 159 NONAME
+	pjsip_parse_param_imp                    @ 160 NONAME
+	pjsip_parse_rdata                        @ 161 NONAME
+	pjsip_parse_status_line                  @ 162 NONAME
+	pjsip_parse_uri                          @ 163 NONAME
+	pjsip_parse_uri_param_imp                @ 164 NONAME
+	pjsip_parser_const                       @ 165 NONAME
+	pjsip_print_text_body                    @ 166 NONAME
+	pjsip_process_route_set                  @ 167 NONAME
+	pjsip_proxy_authenticate_hdr_create      @ 168 NONAME
+	pjsip_proxy_authorization_hdr_create     @ 169 NONAME
+	pjsip_rdata_get_dlg                      @ 170 NONAME
+	pjsip_rdata_get_tsx                      @ 171 NONAME
+	pjsip_register_hdr_parser                @ 172 NONAME
+	pjsip_register_method                    @ 173 NONAME
+	pjsip_register_uri_parser                @ 174 NONAME
+	pjsip_require_hdr_create                 @ 175 NONAME
+	pjsip_require_hdr_init                   @ 176 NONAME
+	pjsip_resolve                            @ 177 NONAME
+	pjsip_resolver_create                    @ 178 NONAME
+	pjsip_resolver_destroy                   @ 179 NONAME
+	pjsip_resolver_get_resolver              @ 180 NONAME
+	pjsip_resolver_set_resolver              @ 181 NONAME
+	pjsip_retry_after_hdr_create             @ 182 NONAME
+	pjsip_retry_after_hdr_init               @ 183 NONAME
+	pjsip_role_name                          @ 184 NONAME
+	pjsip_route_hdr_create                   @ 185 NONAME
+	pjsip_route_hdr_init                     @ 186 NONAME
+	pjsip_routing_hdr_set_route              @ 187 NONAME
+	pjsip_routing_hdr_set_rr                 @ 188 NONAME
+	pjsip_rr_hdr_create                      @ 189 NONAME
+	pjsip_rr_hdr_init                        @ 190 NONAME
+	pjsip_rx_data_get_info                   @ 191 NONAME
+	pjsip_sip_uri_assign                     @ 192 NONAME
+	pjsip_sip_uri_create                     @ 193 NONAME
+	pjsip_sip_uri_init                       @ 194 NONAME
+	pjsip_sip_uri_set_secure                 @ 195 NONAME
+	pjsip_strerror                           @ 196 NONAME
+	pjsip_supported_hdr_create               @ 197 NONAME
+	pjsip_supported_hdr_init                 @ 198 NONAME
+	pjsip_tcp_transport_start                @ 199 NONAME
+	pjsip_tcp_transport_start2               @ 200 NONAME
+	pjsip_tel_nb_cmp                         @ 201 NONAME
+	pjsip_tel_uri_create                     @ 202 NONAME
+	pjsip_to_hdr_create                      @ 203 NONAME
+	pjsip_to_hdr_init                        @ 204 NONAME
+	pjsip_tpmgr_acquire_transport            @ 205 NONAME
+	pjsip_tpmgr_create                       @ 206 NONAME
+	pjsip_tpmgr_destroy                      @ 207 NONAME
+	pjsip_tpmgr_dump_transports              @ 208 NONAME
+	pjsip_tpmgr_find_local_addr              @ 209 NONAME
+	pjsip_tpmgr_get_transport_count          @ 210 NONAME
+	pjsip_tpmgr_receive_packet               @ 211 NONAME
+	pjsip_tpmgr_register_tpfactory           @ 212 NONAME
+	pjsip_tpmgr_send_raw                     @ 213 NONAME
+	pjsip_tpmgr_unregister_tpfactory         @ 214 NONAME
+	pjsip_tpselector_add_ref                 @ 215 NONAME
+	pjsip_tpselector_dec_ref                 @ 216 NONAME
+	pjsip_transport_add_ref                  @ 217 NONAME
+	pjsip_transport_dec_ref                  @ 218 NONAME
+	pjsip_transport_destroy                  @ 219 NONAME
+	pjsip_transport_get_default_port_for_type @ 220 NONAME
+	pjsip_transport_get_flag_from_type       @ 221 NONAME
+	pjsip_transport_get_type_from_flag       @ 222 NONAME
+	pjsip_transport_get_type_from_name       @ 223 NONAME
+	pjsip_transport_get_type_name            @ 224 NONAME
+	pjsip_transport_register                 @ 225 NONAME
+	pjsip_transport_register_type            @ 226 NONAME
+	pjsip_transport_send                     @ 227 NONAME
+	pjsip_transport_shutdown                 @ 228 NONAME
+	pjsip_tsx_create_key                     @ 229 NONAME
+	pjsip_tsx_create_uac                     @ 230 NONAME
+	pjsip_tsx_create_uas                     @ 231 NONAME
+	pjsip_tsx_get_dlg                        @ 232 NONAME
+	pjsip_tsx_layer_destroy                  @ 233 NONAME
+	pjsip_tsx_layer_dump                     @ 234 NONAME
+	pjsip_tsx_layer_find_tsx                 @ 235 NONAME
+	pjsip_tsx_layer_init_module              @ 236 NONAME
+	pjsip_tsx_layer_instance                 @ 237 NONAME
+	pjsip_tsx_recv_msg                       @ 238 NONAME
+	pjsip_tsx_retransmit_no_state            @ 239 NONAME
+	pjsip_tsx_send_msg                       @ 240 NONAME
+	pjsip_tsx_set_transport                  @ 241 NONAME
+	pjsip_tsx_state_str                      @ 242 NONAME
+	pjsip_tsx_stop_retransmit                @ 243 NONAME
+	pjsip_tsx_terminate                      @ 244 NONAME
+	pjsip_tx_data_add_ref                    @ 245 NONAME
+	pjsip_tx_data_create                     @ 246 NONAME
+	pjsip_tx_data_dec_ref                    @ 247 NONAME
+	pjsip_tx_data_get_info                   @ 248 NONAME
+	pjsip_tx_data_invalidate_msg             @ 249 NONAME
+	pjsip_tx_data_is_valid                   @ 250 NONAME
+	pjsip_tx_data_set_transport              @ 251 NONAME
+	pjsip_ua_destroy                         @ 252 NONAME
+	pjsip_ua_dump                            @ 253 NONAME
+	pjsip_ua_find_dialog                     @ 254 NONAME
+	pjsip_ua_get_endpt                       @ 255 NONAME
+	pjsip_ua_init_module                     @ 256 NONAME
+	pjsip_ua_instance                        @ 257 NONAME
+	pjsip_ua_register_dlg                    @ 258 NONAME
+	pjsip_ua_unregister_dlg                  @ 259 NONAME
+	pjsip_udp_transport_attach               @ 260 NONAME
+	pjsip_udp_transport_get_socket           @ 261 NONAME
+	pjsip_udp_transport_pause                @ 262 NONAME
+	pjsip_udp_transport_restart              @ 263 NONAME
+	pjsip_udp_transport_start                @ 264 NONAME
+	pjsip_unsupported_hdr_create             @ 265 NONAME
+	pjsip_unsupported_hdr_init               @ 266 NONAME
+	pjsip_via_hdr_create                     @ 267 NONAME
+	pjsip_via_hdr_init                       @ 268 NONAME
+	pjsip_warning_hdr_create                 @ 269 NONAME
+	pjsip_warning_hdr_create_from_status     @ 270 NONAME
+	pjsip_www_authenticate_hdr_create        @ 271 NONAME