Index: pjproject/trunk/build.symbian/pjnathU.def
===================================================================
--- pjproject/trunk/build.symbian/pjnathU.def	(revision 1503)
+++ pjproject/trunk/build.symbian/pjnathU.def	(revision 1504)
@@ -46,42 +46,43 @@
 	pj_stun_get_err_reason                   @ 45 NONAME
 	pj_stun_get_method_name                  @ 46 NONAME
-	pj_stun_msg_add_attr                     @ 47 NONAME
-	pj_stun_msg_add_binary_attr              @ 48 NONAME
-	pj_stun_msg_add_empty_attr               @ 49 NONAME
-	pj_stun_msg_add_errcode_attr             @ 50 NONAME
-	pj_stun_msg_add_msgint_attr              @ 51 NONAME
-	pj_stun_msg_add_sockaddr_attr            @ 52 NONAME
-	pj_stun_msg_add_string_attr              @ 53 NONAME
-	pj_stun_msg_add_uint64_attr              @ 54 NONAME
-	pj_stun_msg_add_uint_attr                @ 55 NONAME
-	pj_stun_msg_add_unknown_attr             @ 56 NONAME
-	pj_stun_msg_check                        @ 57 NONAME
-	pj_stun_msg_create                       @ 58 NONAME
-	pj_stun_msg_create_response              @ 59 NONAME
-	pj_stun_msg_decode                       @ 60 NONAME
-	pj_stun_msg_destroy_tdata                @ 61 NONAME
-	pj_stun_msg_dump                         @ 62 NONAME
-	pj_stun_msg_encode                       @ 63 NONAME
-	pj_stun_msg_find_attr                    @ 64 NONAME
-	pj_stun_msgint_attr_create               @ 65 NONAME
-	pj_stun_session_cancel_req               @ 66 NONAME
-	pj_stun_session_create                   @ 67 NONAME
-	pj_stun_session_create_ind               @ 68 NONAME
-	pj_stun_session_create_req               @ 69 NONAME
-	pj_stun_session_create_res               @ 70 NONAME
-	pj_stun_session_destroy                  @ 71 NONAME
-	pj_stun_session_get_user_data            @ 72 NONAME
-	pj_stun_session_on_rx_pkt                @ 73 NONAME
-	pj_stun_session_retransmit_req           @ 74 NONAME
-	pj_stun_session_send_msg                 @ 75 NONAME
-	pj_stun_session_set_credential           @ 76 NONAME
-	pj_stun_session_set_server_name          @ 77 NONAME
-	pj_stun_session_set_user_data            @ 78 NONAME
-	pj_stun_set_padding_char                 @ 79 NONAME
-	pj_stun_sockaddr_attr_create             @ 80 NONAME
-	pj_stun_string_attr_create               @ 81 NONAME
-	pj_stun_uint64_attr_create               @ 82 NONAME
-	pj_stun_uint_attr_create                 @ 83 NONAME
-	pj_stun_unknown_attr_create              @ 84 NONAME
-	pjnath_init                              @ 85 NONAME
-	pjnath_perror                            @ 86 NONAME
+	pj_stun_get_nat_name                     @ 47 NONAME
+	pj_stun_msg_add_attr                     @ 48 NONAME
+	pj_stun_msg_add_binary_attr              @ 49 NONAME
+	pj_stun_msg_add_empty_attr               @ 50 NONAME
+	pj_stun_msg_add_errcode_attr             @ 51 NONAME
+	pj_stun_msg_add_msgint_attr              @ 52 NONAME
+	pj_stun_msg_add_sockaddr_attr            @ 53 NONAME
+	pj_stun_msg_add_string_attr              @ 54 NONAME
+	pj_stun_msg_add_uint64_attr              @ 55 NONAME
+	pj_stun_msg_add_uint_attr                @ 56 NONAME
+	pj_stun_msg_add_unknown_attr             @ 57 NONAME
+	pj_stun_msg_check                        @ 58 NONAME
+	pj_stun_msg_create                       @ 59 NONAME
+	pj_stun_msg_create_response              @ 60 NONAME
+	pj_stun_msg_decode                       @ 61 NONAME
+	pj_stun_msg_destroy_tdata                @ 62 NONAME
+	pj_stun_msg_dump                         @ 63 NONAME
+	pj_stun_msg_encode                       @ 64 NONAME
+	pj_stun_msg_find_attr                    @ 65 NONAME
+	pj_stun_msgint_attr_create               @ 66 NONAME
+	pj_stun_session_cancel_req               @ 67 NONAME
+	pj_stun_session_create                   @ 68 NONAME
+	pj_stun_session_create_ind               @ 69 NONAME
+	pj_stun_session_create_req               @ 70 NONAME
+	pj_stun_session_create_res               @ 71 NONAME
+	pj_stun_session_destroy                  @ 72 NONAME
+	pj_stun_session_get_user_data            @ 73 NONAME
+	pj_stun_session_on_rx_pkt                @ 74 NONAME
+	pj_stun_session_retransmit_req           @ 75 NONAME
+	pj_stun_session_send_msg                 @ 76 NONAME
+	pj_stun_session_set_credential           @ 77 NONAME
+	pj_stun_session_set_server_name          @ 78 NONAME
+	pj_stun_session_set_user_data            @ 79 NONAME
+	pj_stun_set_padding_char                 @ 80 NONAME
+	pj_stun_sockaddr_attr_create             @ 81 NONAME
+	pj_stun_string_attr_create               @ 82 NONAME
+	pj_stun_uint64_attr_create               @ 83 NONAME
+	pj_stun_uint_attr_create                 @ 84 NONAME
+	pj_stun_unknown_attr_create              @ 85 NONAME
+	pjnath_init                              @ 86 NONAME
+	pjnath_perror                            @ 87 NONAME
Index: pjproject/trunk/build.symbian/pjsua_libU.def
===================================================================
--- pjproject/trunk/build.symbian/pjsua_libU.def	(revision 1503)
+++ pjproject/trunk/build.symbian/pjsua_libU.def	(revision 1504)
@@ -76,42 +76,43 @@
 	pjsua_get_buddy_count                    @ 75 NONAME
 	pjsua_get_ec_tail                        @ 76 NONAME
-	pjsua_get_pjmedia_endpt                  @ 77 NONAME
-	pjsua_get_pjsip_endpt                    @ 78 NONAME
-	pjsua_get_pool_factory                   @ 79 NONAME
-	pjsua_get_snd_dev                        @ 80 NONAME
-	pjsua_handle_events                      @ 81 NONAME
-	pjsua_im_send                            @ 82 NONAME
-	pjsua_im_typing                          @ 83 NONAME
-	pjsua_init                               @ 84 NONAME
-	pjsua_logging_config_default             @ 85 NONAME
-	pjsua_logging_config_dup                 @ 86 NONAME
-	pjsua_media_config_default               @ 87 NONAME
-	pjsua_media_transports_create            @ 88 NONAME
-	pjsua_msg_data_init                      @ 89 NONAME
-	pjsua_perror                             @ 90 NONAME
-	pjsua_player_create                      @ 91 NONAME
-	pjsua_player_destroy                     @ 92 NONAME
-	pjsua_player_get_conf_port               @ 93 NONAME
-	pjsua_player_get_port                    @ 94 NONAME
-	pjsua_player_set_pos                     @ 95 NONAME
-	pjsua_playlist_create                    @ 96 NONAME
-	pjsua_pool_create                        @ 97 NONAME
-	pjsua_pres_dump                          @ 98 NONAME
-	pjsua_reconfigure_logging                @ 99 NONAME
-	pjsua_recorder_create                    @ 100 NONAME
-	pjsua_recorder_destroy                   @ 101 NONAME
-	pjsua_recorder_get_conf_port             @ 102 NONAME
-	pjsua_recorder_get_port                  @ 103 NONAME
-	pjsua_set_ec                             @ 104 NONAME
-	pjsua_set_no_snd_dev                     @ 105 NONAME
-	pjsua_set_null_snd_dev                   @ 106 NONAME
-	pjsua_set_snd_dev                        @ 107 NONAME
-	pjsua_start                              @ 108 NONAME
-	pjsua_transport_close                    @ 109 NONAME
-	pjsua_transport_config_default           @ 110 NONAME
-	pjsua_transport_config_dup               @ 111 NONAME
-	pjsua_transport_create                   @ 112 NONAME
-	pjsua_transport_get_info                 @ 113 NONAME
-	pjsua_transport_register                 @ 114 NONAME
-	pjsua_transport_set_enable               @ 115 NONAME
-	pjsua_verify_sip_url                     @ 116 NONAME
+	pjsua_get_nat_type                       @ 77 NONAME
+	pjsua_get_pjmedia_endpt                  @ 78 NONAME
+	pjsua_get_pjsip_endpt                    @ 79 NONAME
+	pjsua_get_pool_factory                   @ 80 NONAME
+	pjsua_get_snd_dev                        @ 81 NONAME
+	pjsua_handle_events                      @ 82 NONAME
+	pjsua_im_send                            @ 83 NONAME
+	pjsua_im_typing                          @ 84 NONAME
+	pjsua_init                               @ 85 NONAME
+	pjsua_logging_config_default             @ 86 NONAME
+	pjsua_logging_config_dup                 @ 87 NONAME
+	pjsua_media_config_default               @ 88 NONAME
+	pjsua_media_transports_create            @ 89 NONAME
+	pjsua_msg_data_init                      @ 90 NONAME
+	pjsua_perror                             @ 91 NONAME
+	pjsua_player_create                      @ 92 NONAME
+	pjsua_player_destroy                     @ 93 NONAME
+	pjsua_player_get_conf_port               @ 94 NONAME
+	pjsua_player_get_port                    @ 95 NONAME
+	pjsua_player_set_pos                     @ 96 NONAME
+	pjsua_playlist_create                    @ 97 NONAME
+	pjsua_pool_create                        @ 98 NONAME
+	pjsua_pres_dump                          @ 99 NONAME
+	pjsua_reconfigure_logging                @ 100 NONAME
+	pjsua_recorder_create                    @ 101 NONAME
+	pjsua_recorder_destroy                   @ 102 NONAME
+	pjsua_recorder_get_conf_port             @ 103 NONAME
+	pjsua_recorder_get_port                  @ 104 NONAME
+	pjsua_set_ec                             @ 105 NONAME
+	pjsua_set_no_snd_dev                     @ 106 NONAME
+	pjsua_set_null_snd_dev                   @ 107 NONAME
+	pjsua_set_snd_dev                        @ 108 NONAME
+	pjsua_start                              @ 109 NONAME
+	pjsua_transport_close                    @ 110 NONAME
+	pjsua_transport_config_default           @ 111 NONAME
+	pjsua_transport_config_dup               @ 112 NONAME
+	pjsua_transport_create                   @ 113 NONAME
+	pjsua_transport_get_info                 @ 114 NONAME
+	pjsua_transport_register                 @ 115 NONAME
+	pjsua_transport_set_enable               @ 116 NONAME
+	pjsua_verify_sip_url                     @ 117 NONAME
Index: pjproject/trunk/pjlib/include/pj/config_site_sample.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/config_site_sample.h	(revision 1503)
+++ pjproject/trunk/pjlib/include/pj/config_site_sample.h	(revision 1504)
@@ -42,5 +42,5 @@
 
     /* Disable these */
-#   define PJMEDIA_HAS_LIBRESAMPLE	0
+#   define PJMEDIA_RESAMPLE_IMP		PJMEDIA_RESAMPLE_NONE
 #   define PJMEDIA_HAS_SPEEX_AEC	0
 
Index: pjproject/trunk/pjnath/src/pjnath/nat_detect.c
===================================================================
--- pjproject/trunk/pjnath/src/pjnath/nat_detect.c	(revision 1503)
+++ pjproject/trunk/pjnath/src/pjnath/nat_detect.c	(revision 1504)
@@ -170,5 +170,5 @@
     pj_status_t status;
 
-    status = pj_sock_socket(PJ_AF_INET, PJ_SOCK_DGRAM, 0, &sock);
+    status = pj_sock_socket(pj_AF_INET(), pj_SOCK_DGRAM(), 0, &sock);
     if (status != PJ_SUCCESS)
 	return status;
@@ -245,5 +245,5 @@
      * Initialize socket.
      */
-    status = pj_sock_socket(PJ_AF_INET, PJ_SOCK_DGRAM, 0, &sess->sock);
+    status = pj_sock_socket(pj_AF_INET(), pj_SOCK_DGRAM(), 0, &sess->sock);
     if (status != PJ_SUCCESS)
 	goto on_error;
@@ -253,5 +253,5 @@
      */
     pj_bzero(&sess->local_addr, sizeof(pj_sockaddr_in));
-    sess->local_addr.sin_family = PJ_AF_INET;
+    sess->local_addr.sin_family = pj_AF_INET();
     status = pj_sock_bind(sess->sock, &sess->local_addr, 
 			  sizeof(pj_sockaddr_in));
@@ -526,6 +526,6 @@
 	PJ_LOG(4,(sess->pool->obj_name, "Invalid transaction ID %u in response",
 		  test_id));
-	end_session(sess, status, 
-		    PJ_STATUS_FROM_STUN_CODE(PJ_STUN_SC_SERVER_ERROR));
+	end_session(sess, PJ_STATUS_FROM_STUN_CODE(PJ_STUN_SC_SERVER_ERROR),
+		    PJ_STUN_NAT_TYPE_ERR_UNKNOWN);
 	return;
     }
Index: pjproject/trunk/pjsip-apps/src/symbian_ua/main_symbian.cpp
===================================================================
--- pjproject/trunk/pjsip-apps/src/symbian_ua/main_symbian.cpp	(revision 1503)
+++ pjproject/trunk/pjsip-apps/src/symbian_ua/main_symbian.cpp	(revision 1504)
@@ -83,5 +83,5 @@
 void MyTask::RunL()
 {
-    int rc = ua_main();
+    ua_main();
     asw_->AsyncStop();
 }